define(["require", "exports", "tslib", "./grid-stack-item.html", "aurelia", "../../interceptors"], function (require, exports, tslib_1, __au2ViewDef, aurelia_1, interceptors_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.GridStackItem = void 0;
    __au2ViewDef = tslib_1.__importStar(__au2ViewDef);
    var GridStackItem = /** @class */ (function () {
        function GridStackItem(root) {
            this.root = root;
        }
        GridStackItem.prototype.xChanged = function () {
            if (this.x !== undefined) {
                this.root.setAttribute('gs-x', this.x.toString());
            }
            else {
                this.root.removeAttribute('gs-x');
            }
        };
        GridStackItem.prototype.yChanged = function () {
            if (this.y !== undefined) {
                this.root.setAttribute('gs-y', this.y.toString());
            }
            else {
                this.root.removeAttribute('gs-y');
            }
        };
        GridStackItem.prototype.wChanged = function () {
            if (this.w !== undefined) {
                this.root.setAttribute('gs-w', this.w.toString());
            }
            else {
                this.root.removeAttribute('gs-w');
            }
        };
        GridStackItem.prototype.hChanged = function () {
            if (this.h !== undefined) {
                this.root.setAttribute('gs-h', this.h.toString());
            }
            else {
                this.root.removeAttribute('gs-h');
            }
        };
        GridStackItem.prototype.minWChanged = function () {
            if (this.minW !== undefined) {
                this.root.setAttribute('gs-min-w', this.minW.toString());
            }
            else {
                this.root.removeAttribute('gs-min-w');
            }
        };
        GridStackItem.prototype.minHChanged = function () {
            if (this.minH !== undefined) {
                this.root.setAttribute('gs-min-h', this.minH.toString());
            }
            else {
                this.root.removeAttribute('gs-min-h');
            }
        };
        GridStackItem.prototype.maxWChanged = function () {
            if (this.maxW !== undefined) {
                this.root.setAttribute('gs-max-w', this.maxW.toString());
            }
            else {
                this.root.removeAttribute('gs-max-w');
            }
        };
        GridStackItem.prototype.maxHChanged = function () {
            if (this.maxH !== undefined) {
                this.root.setAttribute('gs-max-h', this.maxH.toString());
            }
            else {
                this.root.removeAttribute('gs-max-h');
            }
        };
        GridStackItem.prototype.idChanged = function () {
            if (this.id !== undefined) {
                this.root.setAttribute('gs-id', this.id.toString());
            }
            else {
                this.root.removeAttribute('gs-id');
            }
        };
        GridStackItem.prototype.noMoveChanged = function () {
            if (this.noMove) {
                this.root.setAttribute('gs-no-move', 'true');
            }
            else {
                this.root.removeAttribute('gs-no-move');
            }
        };
        GridStackItem.prototype.noResizeChanged = function () {
            if (this.noResize) {
                this.root.setAttribute('gs-no-resize', 'true');
            }
            else {
                this.root.removeAttribute('gs-no-resize');
            }
        };
        GridStackItem.prototype.lockedChanged = function () {
            if (this.locked) {
                this.root.setAttribute('gs-locked', 'true');
            }
            else {
                this.root.removeAttribute('gs-locked');
            }
        };
        GridStackItem.prototype.autoPositionChanged = function () {
            if (this.autoPosition) {
                this.root.setAttribute('gs-auto-position', 'true');
            }
            else {
                this.root.removeAttribute('gs-auto-position');
            }
        };
        GridStackItem.prototype.resizeHandlesChanged = function () {
            if (this.resizeHandles !== undefined) {
                this.root.setAttribute('gs-resize-handles', this.resizeHandles.toString());
            }
            else {
                this.root.removeAttribute('gs-resize-handles');
            }
        };
        GridStackItem.prototype.attached = function () {
            if (this.x !== undefined) {
                this.xChanged();
            }
            if (this.y !== undefined) {
                this.yChanged();
            }
            if (this.w !== undefined) {
                this.wChanged();
            }
            if (this.h !== undefined) {
                this.hChanged();
            }
            if (this.minW !== undefined) {
                this.minWChanged();
            }
            if (this.minH !== undefined) {
                this.minHChanged();
            }
            if (this.maxW !== undefined) {
                this.maxWChanged();
            }
            if (this.maxH !== undefined) {
                this.maxHChanged();
            }
            if (this.noMove !== undefined) {
                this.noMoveChanged();
            }
            if (this.noResize !== undefined) {
                this.noResizeChanged();
            }
            if (this.locked !== undefined) {
                this.lockedChanged();
            }
            if (this.id !== undefined) {
                this.idChanged();
            }
            if (this.autoPosition !== undefined) {
                this.autoPositionChanged();
            }
            if (this.resizeHandles !== undefined) {
                this.resizeHandlesChanged();
            }
        };
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "x", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "y", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "w", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "h", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "minW", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "minH", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "maxW", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "maxH", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number, mode: 6 /* BindingMode.twoWay */ }),
            tslib_1.__metadata("design:type", Number)
        ], GridStackItem.prototype, "id", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.booleanAttr }),
            tslib_1.__metadata("design:type", Boolean)
        ], GridStackItem.prototype, "noMove", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.booleanAttr }),
            tslib_1.__metadata("design:type", Boolean)
        ], GridStackItem.prototype, "noResize", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.booleanAttr }),
            tslib_1.__metadata("design:type", Boolean)
        ], GridStackItem.prototype, "locked", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.booleanAttr }),
            tslib_1.__metadata("design:type", Boolean)
        ], GridStackItem.prototype, "autoPosition", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.handlesAttr }),
            tslib_1.__metadata("design:type", Array)
        ], GridStackItem.prototype, "resizeHandles", void 0);
        GridStackItem = tslib_1.__decorate([
            (0, aurelia_1.customElement)(__au2ViewDef),
            (0, aurelia_1.inject)(Element),
            (0, aurelia_1.customElement)('grid-stack-item'),
            tslib_1.__metadata("design:paramtypes", [Object])
        ], GridStackItem);
        return GridStackItem;
    }());
    exports.GridStackItem = GridStackItem;
});
//# sourceMappingURL=grid-stack-item.js.map
