define(["require", "exports", "tslib", "./grid-stack.html", "aurelia", "../../interceptors", "gridstack"], function (require, exports, tslib_1, __au2ViewDef, aurelia_1, interceptors_1, gs) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.GridStack = void 0;
    __au2ViewDef = tslib_1.__importStar(__au2ViewDef);
    gs = tslib_1.__importStar(gs);
    var GridStack = /** @class */ (function () {
        function GridStack(root) {
            this.root = root;
        }
        GridStack.prototype.minRowChanged = function () {
            this.root.setAttribute('gs-min-row', this.minRow.toString());
        };
        GridStack.prototype.floatChanged = function () {
            var _a;
            (_a = this.grid) === null || _a === void 0 ? void 0 : _a.float(this.float);
        };
        GridStack.prototype.staticChanged = function () {
            var _a;
            (_a = this.grid) === null || _a === void 0 ? void 0 : _a.setStatic(this.static);
        };
        GridStack.prototype.itemsChanged = function () {
            var _this = this;
            if (!this.grid || !this.items) {
                return;
            }
            var removed = this.grid.engine.nodes.filter(function (x) { var _a; return !((_a = x.el) === null || _a === void 0 ? void 0 : _a.classList.contains('grid-stack-placeholder')) && !_this.items.find(function (y) { return y.root === x.el; }); });
            removed.forEach(function (x) { return _this.grid.engine.removeNode(x, false, false); });
            var newItems = this.items.map(function (x) { return x.root; }).filter(function (x) { return !x.gridstackNode; });
            newItems.forEach(function (x) {
                _this.grid.addWidget(x);
                if (x.gridstackNode) {
                    _this.updateNodeVmAttributes(x.gridstackNode);
                }
            });
        };
        GridStack.prototype.attached = function () {
            var _a;
            var options = (_a = this.options) !== null && _a !== void 0 ? _a : {};
            if (this.float !== undefined) {
                options.float = this.float;
            }
            if (this.static !== undefined) {
                options.staticGrid = this.static;
            }
            this.grid = gs.GridStack.init(options, this.root);
        };
        GridStack.prototype.detached = function () {
            this.grid.destroy();
        };
        GridStack.prototype.handleChange = function (nodes) {
            var _this = this;
            nodes.forEach(function (x) { return _this.updateNodeVmAttributes(x); });
        };
        GridStack.prototype.updateNodeVmAttributes = function (node) {
            if (node.el) {
                var itemVm = aurelia_1.CustomElement.for(node.el).viewModel;
                itemVm.x = node.x;
                itemVm.y = node.y;
                itemVm.w = node.w;
                itemVm.h = node.h;
            }
        };
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.number }),
            tslib_1.__metadata("design:type", Number)
        ], GridStack.prototype, "minRow", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.booleanAttr }),
            tslib_1.__metadata("design:type", Boolean)
        ], GridStack.prototype, "float", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.bindable)({ set: interceptors_1.booleanAttr }),
            tslib_1.__metadata("design:type", Boolean)
        ], GridStack.prototype, "static", void 0);
        tslib_1.__decorate([
            aurelia_1.bindable,
            tslib_1.__metadata("design:type", Object)
        ], GridStack.prototype, "options", void 0);
        tslib_1.__decorate([
            (0, aurelia_1.children)({ filter: function (el) { return el.tagName === 'GRID-STACK-ITEM'; } }),
            tslib_1.__metadata("design:type", Array)
        ], GridStack.prototype, "items", void 0);
        GridStack = tslib_1.__decorate([
            (0, aurelia_1.customElement)(__au2ViewDef),
            (0, aurelia_1.inject)(Element),
            (0, aurelia_1.customElement)('grid-stack'),
            tslib_1.__metadata("design:paramtypes", [HTMLElement])
        ], GridStack);
        return GridStack;
    }());
    exports.GridStack = GridStack;
});
//# sourceMappingURL=grid-stack.js.map
