define(["require", "exports", "./models"], function (require, exports, models_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.handlesAttr = exports.booleanAttr = exports.number = void 0;
    function number(a) {
        return Number(a);
    }
    exports.number = number;
    function booleanAttr(val) {
        return val || val === '' ? true : false;
    }
    exports.booleanAttr = booleanAttr;
    function onlyUnique(value, index, self) {
        return self.indexOf(value) === index;
    }
    function handlesAttr(handles) {
        if (!handles) {
            return [];
        }
        var allEntries;
        if (typeof handles === 'string') {
            allEntries = handles.replace(/\s/g, '').split(',');
        }
        else if (Array.isArray(handles)) {
            allEntries = handles;
        }
        else {
            return [];
        }
        // remove duplicates
        allEntries = allEntries.filter(onlyUnique);
        // add only ResizeHandleType items
        var handlesArray = [];
        allEntries.forEach(function (child) {
            if (child in models_1.ResizeHandles) {
                handlesArray.push(child);
            }
        });
        return handlesArray;
    }
    exports.handlesAttr = handlesAttr;
});
//# sourceMappingURL=interceptors.js.map
